diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
index caeac86ae..169e03488 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
@@ -2,7 +2,7 @@ package net.minecraft.client.gui.options.components;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.lang.Language;
@@ -97,7 +97,6 @@ public class LanguagePackListComponent
         }
 
         public void render(int x, int y, int width, int mouseX, int mouseY) {
-            Font textRenderer = mc.font;
             Tessellator tessellator = Tessellator.instance;
 
             if (mc.gameSettings.language.value.equals(languagePack.getId())) {
@@ -132,28 +131,19 @@ public class LanguagePackListComponent
             if (region != null) {
                 sb.append(" (").append(region).append(")");
             }
-            String fullName = sb.toString();
-            StringBuilder csb = new StringBuilder();
-            Iterator<String> creditsList = languagePack.getCredits().listIterator();
+            final String fullName = sb.toString();
+            final StringBuilder credits = new StringBuilder();
+            final Iterator<String> creditsList = languagePack.getCredits().listIterator();
+            boolean empty = true;
             while (creditsList.hasNext()) {
-                csb.append(creditsList.next());
+                credits.append(creditsList.next());
                 if (creditsList.hasNext()) {
-                    csb.append(", ");
+                    credits.append(", ");
                 }
+                empty = false;
             }
-            String credits = csb.toString();
-            textRenderer.drawCenteredString(
-                fullName,
-                x + (width / 2),
-                y + 1,
-                0xFFFFFF
-            );
-            textRenderer.drawCenteredString(
-                credits.isEmpty() ? "Unknown Credits" : credits,
-                x + width / 2,
-                y + 12,
-                0x808080
-            );
+            FontHelper.renderCentered(Tessellator.instance, fullName, x + (width / 2), y + 1).setShadow().call(this.mc.font);
+            FontHelper.renderCentered(Tessellator.instance, empty ? "Unknown Credits" : credits, x + width / 2, y + 12).setShadow().setColor(0x808080).call(this.mc.font);
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
index 1768e5c0b..2687ef45a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
@@ -2,6 +2,8 @@ package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ItemElement;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
@@ -83,7 +85,7 @@ public class OptionsCategory
         {
             textColor = 0xFFFFA0;
         }
-        mc.font.drawStringWithShadow((collapsed ? "▷" : "▽"), x, y + PADDING + 10, textColor);
+        FontHelper.render(Tessellator.instance, (this.collapsed ? "▷" : "▽"), x, y + PADDING + 10).setShadow().setColor(textColor).call(mc.font);
 
         int xOffset = 10;
         if (icon != null)
@@ -91,7 +93,7 @@ public class OptionsCategory
             renderItem.render(icon, x + 11, y + PADDING + 5);
             xOffset += 20;
         }
-        mc.font.drawStringWithShadow(i18n.translateKey(translationKey), x + xOffset, y + PADDING + 10, textColor);
+        FontHelper.render(Tessellator.instance, i18n.translateKey(this.translationKey), x + xOffset, y + PADDING + 10).setShadow().setColor(textColor).call(mc.font);
         if (!collapsed) {
             int componentY = TOP_SPACING;
             for (OptionsComponent component : components)
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
index d70b966cb..0e8720107 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
@@ -2,7 +2,7 @@ package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.util.helper.Colors;
@@ -64,7 +64,10 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
         if (selectedPacks.isEmpty()) {
-            mc.font.drawCenteredString(I18n.getInstance().translateKey("gui.options.page.texture_packs.label.no_packs"), x + width / 2, y + 4, 0x5F7F7F7F);
+            FontHelper.renderCentered(Tessellator.instance, I18n.getInstance().translateKey("gui.options.page.texture_packs.label.no_packs"), x + width / 2, y + 4)
+                .setShadow()
+                .setColor(0x5F7F7F7F)
+                .call(mc.font);
         }
         for (TexturePackButton button : selectedPacks) {
             if (button == draggedButton) continue;
@@ -212,7 +215,6 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
 
         public void render(SelectedTexturePackListComponent component, int x, int y, int width, int mouseX, int mouseY) {
             Tessellator tessellator = Tessellator.instance;
-            Font font = mc.font;
 
             setupButton(x, y, width, mouseX, mouseY);
 
@@ -262,21 +264,21 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
 
             if(format == Global.TEXTURE_PACK_FORMAT) {
                 // Correct version
-                font.drawString(texturePack.manifest.getName(),             x + xPos + height + 2, y + yPos + 1, 0xFFFFFF);
-                font.drawString(texturePack.manifest.getDescriptionLine1(), x + xPos + height + 2, y + yPos + 12, 0x808080);
-                font.drawString(texturePack.manifest.getDescriptionLine2(), x + xPos + height + 2, y + yPos + 22, 0x808080);
+                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getName(), x + this.xPos + this.height + 2, y + this.yPos + 1).call(mc.font);
+                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.xPos + this.height + 2, y + this.yPos + 12).setColor(0x808080).call(mc.font);
+                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.xPos + this.height + 2, y + this.yPos + 22).setColor(0x808080).call(mc.font);
             }else if(format == -1) {
                 // Manifest error
-                font.drawString(TextFormatting.RED + texturePack.manifest.getName(), x + xPos + height + 2, y + yPos + 1, 0xFFFFFF);
-                font.drawString(texturePack.manifest.getDescriptionLine1(),          x + xPos + height + 2, y + yPos + 12, 0x808080);
-                font.drawString(texturePack.manifest.getDescriptionLine2(),          x + xPos + height + 2, y + yPos + 22, 0x808080);
+                FontHelper.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.xPos + this.height + 2, y + this.yPos + 1).call(mc.font);
+                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.xPos + this.height + 2, y + this.yPos + 12).setColor(0x808080).call(mc.font);
+                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.xPos + this.height + 2, y + this.yPos + 22).setColor(0x808080).call(mc.font);
                 rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
             }else {
                 // Wrong texture pack version
                 I18n i18n = I18n.getInstance();
-                font.drawString(TextFormatting.RED + texturePack.manifest.getName(),                            x + xPos + height + 2, y + yPos + 1, 0xFFFFFF);
-                font.drawString(i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.1"),  x + xPos + height + 2, y + yPos + 12, 0x808080);
-                font.drawString(i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.2"),  x + xPos + height + 2, y + yPos + 22, 0x808080);
+                FontHelper.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.xPos + this.height + 2, y + this.yPos + 1).call(mc.font);
+                FontHelper.render(Tessellator.instance, i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.1"), x + this.xPos + this.height + 2, y + this.yPos + 12).setColor(0x808080).call(mc.font);
+                FontHelper.render(Tessellator.instance, i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.2"), x + this.xPos + this.height + 2, y + this.yPos + 22).setColor(0x808080).call(mc.font);
                 rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
             }
 
@@ -286,8 +288,8 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
             }
 
             String version = texturePack.manifest.getPackVersion();
-            int versionWidth = font.getStringWidth(version);
-            font.drawString(texturePack.manifest.getPackVersion(), x + xPos + width - versionWidth - 2, y + yPos + 1, rgbVersion);
+            int versionWidth = mc.font.stringWidth(version);
+            FontHelper.render(Tessellator.instance, this.texturePack.manifest.getPackVersion(), x + this.xPos + width - versionWidth - 2, y + this.yPos + 1).setColor(rgbVersion).call(mc.font);
         }
         public void setupButton(int x, int y, int width, int mouseX, int mouseY){
             button.setX(x + xPos + width - button.width - 1);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
index 2aa7d2655..984d1d2a5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
@@ -14,6 +14,7 @@ public class TooltipPickerComponent
         super(option);
 
         this.tooltip = new TooltipElement(mc);
+        this.slider.renderText = false;
     }
 
     @Override
@@ -22,9 +23,10 @@ public class TooltipPickerComponent
 
         final int padding = 3;
         final int yOffset = 0;
-        final int stringWidth = mc.font.getStringWidth(this.option.getDisplayStringValue()) + padding * 2;
+        final int stringWidth = mc.font.stringWidth(this.option.getDisplayStringValue());
+        final int stringHeight = mc.font.fontHeight();
         GL11.glColor4f(1, 1, 1, 1);
-        this.tooltip.render(this.option.getDisplayStringValue(), x + relativeButtonX + buttonWidth / 2 - stringWidth / 2, y + relativeButtonY + 3 + yOffset, 0, 0);
+        this.tooltip.render(this.option.getDisplayStringValue(), x + relativeButtonX + buttonWidth/2 - stringWidth/2, y + relativeButtonY + buttonHeight/2 - stringHeight/2, 0, 0, -1, -1, false);
 
         if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
             mc.currentScreen.setDesiredCursor(CursorShape.HAND);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index c2392c95d..d520763ea 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -4,6 +4,7 @@ import net.betterthanadventure.utils.DataDumper;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.enums.EnumGPUVendor;
 import net.minecraft.client.gui.ScreenControllerSetup;
+import net.minecraft.client.gui.ScreenFontTest;
 import net.minecraft.client.gui.ScreenHudDesigner;
 import net.minecraft.client.gui.ScreenSoundTest;
 import net.minecraft.client.gui.ScreenTextureViewer;
@@ -359,6 +360,7 @@ public abstract class OptionsPages
                     new Thread(() -> SeedViewerMain.main(new String[0])).start();
                     Global.accessor = mc;
                 }))
+                .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.font_tester", () -> mc.displayScreen(new ScreenFontTest(mc.currentScreen))))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.datadumper", () ->{
                     DataDumper.main(new String[0]);
                     FileOpener.open(new File(mc.getMinecraftDir(), "infodump"));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java b/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
index 1c6e6ff62..65c256665 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
@@ -107,7 +107,7 @@ public class ScreenPaged
                 textColor = 0xFFFFFFA0;
             }
             renderItem.render(page.getIcon(), x, y2 + (PAGE_BUTTON_HEIGHT / 2) - 9);
-            mc.font.drawStringWithShadow(translated, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
+            drawStringShadow(this.fontRenderer, translated, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
             y2 += PAGE_BUTTON_HEIGHT;
         }
     }
@@ -257,7 +257,7 @@ public class ScreenPaged
 
         overlayBackground(leftWidth, leftWidth + SEPARATOR_WIDTH, top, bottom);
 
-        drawStringCentered(font, i18n.translateKey(titleTranslationKey), width / 2, 5, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, i18n.translateKey(titleTranslationKey), width / 2, 5, 0xffffff);
 
         drawRightPanelScrollBar(mx, my);
         drawLeftPanelScrollBar(mx, my);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
index bd8c6f156..362e4629f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
@@ -1,19 +1,20 @@
 package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
+import net.minecraft.client.render.tessellator.Tessellator;
 
 public class LabelComponent
     extends PopupComponent
 {
-    private final Font fr;
+    private final FontRenderer fontRenderer;
     private final String text;
     private final int color;
 
-    public LabelComponent(int width, String text, int color)
-    {
+    public LabelComponent(final int width, final String text, final int color) {
         super(width);
-        this.fr = Minecraft.getMinecraft().font;
+        this.fontRenderer = Minecraft.getMinecraft().font;
         this.text = text;
         this.color = color;
     }
@@ -25,10 +26,8 @@ public class LabelComponent
     }
 
     @Override
-    public void render(int x, int y, int mouseX, int mouseY)
-    {
-        int middle = (x - PopupScreen.HORIZONTAL_MARGIN) + getWidth() / 2;
-
-        fr.drawCenteredString(text, middle, y, color);
+    public void render(final int x, final int y, final int mouseX, final int mouseY) {
+        final int middle = (x - PopupScreen.HORIZONTAL_MARGIN) + getWidth() / 2;
+        FontHelper.renderCentered(Tessellator.instance, this.text, middle, y).setShadow().setColor(this.color).call(this.fontRenderer);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
index d34d7efd1..52d0dac0c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
@@ -2,7 +2,9 @@ package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Scissor;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
@@ -14,6 +16,7 @@ import java.util.List;
 public class MessageBoxComponent
     extends PopupComponent
 {
+    private static final String FORMAT_REGEX = "[" + TextFormatting.FORMAT_CHARS + "]";
     private final Minecraft minecraft;
     private float scrollAmount = 0;
     private final List<String> lines = new ArrayList<>();
@@ -68,7 +71,7 @@ public class MessageBoxComponent
                 if (word.contains("§")) {
                     if (word.indexOf('§') < word.length() - 1) {
                         String format = String.valueOf(word.charAt(word.indexOf('§') + 1));
-                        if (format.matches("[0123456789abcdefklmnor]")) { //if matches any valid text format
+                        if (format.matches(FORMAT_REGEX)) { //if matches any valid text format
                             currentFormat = "§" + format;
                         }
                     }
@@ -124,7 +127,7 @@ public class MessageBoxComponent
         // Draw lines
         for (int i = 0; i < lines.size(); i++)
         {
-            minecraft.font.drawStringWithShadow(lines.get(i),x + 4,(y + 4) + (i * 12) - getScrollPixels(),0xFFFFFFFF);
+            FontHelper.render(Tessellator.instance, lines.get(i),x + 4,(y + 4) + (i * 12) - getScrollPixels()).setShadow().call(this.minecraft.font);
         }
 
         Scissor.disable();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java b/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
index eaafc2209..d9313b0ba 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
@@ -90,9 +90,9 @@ public class GuiElementToastsHud extends Gui {
             String s = I18n.getInstance().translateKeyAndFormat("gui.achievement.label.unlicensed.1", Global.VERSION);
             String s1 = I18n.getInstance().translateKey("gui.achievement.label.unlicensed.2");
             String s2 = I18n.getInstance().translateKey("gui.achievement.label.unlicensed.3");
-            mc.font.drawStringWithShadow(s, 2, 2, 0xffffff);
-            mc.font.drawStringWithShadow(s1, 2, 11, 0xffffff);
-            mc.font.drawStringWithShadow(s2, 2, 20, 0xffffff);
+            drawStringShadow(mc.font, s, 2, 2, 0xffffff);
+            drawStringShadow(mc.font, s1, 2, 11, 0xffffff);
+            drawStringShadow(mc.font, s2, 2, 20, 0xffffff);
             GL11.glDepthMask(true);
             GL11.glEnable(GL11.GL_DEPTH_TEST);
         }
@@ -166,10 +166,10 @@ public class GuiElementToastsHud extends Gui {
 
         drawGuiIcon(x, y, TOAST_WIDTH, TOAST_HEIGHT, TextureRegistry.getTexture(toast.getTexture(duration)));
         if(toast.messageOnly(duration)) {
-            mc.font.drawStringIntoConstrainedBlock(toast.getMessage(duration), x + 30, y + 7, 120, toast.descriptionColor(duration));
+            drawStringConstrained(mc.font, toast.getMessage(duration), x + 30, y + 7, 120, toast.descriptionColor(duration));
         } else {
-            mc.font.drawString(toast.getTitle(duration), x + 30, y + 7, toast.nameColor(duration));
-            mc.font.drawString(toast.getMessage(duration), x + 30, y + 18, toast.descriptionColor(duration));
+            drawStringNoShadow(mc.font, toast.getTitle(duration), x + 30, y + 7, toast.nameColor(duration));
+            drawStringNoShadow(mc.font, toast.getMessage(duration), x + 30, y + 18, toast.descriptionColor(duration));
         }
 
         GL11.glDepthMask(true);
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index af733e962..322e568c7 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -275,8 +275,6 @@ public class GameSettings {
 	public GameSettings(Minecraft minecraft, File file) {
 		mc = minecraft;
 		optionsFile = new File(file, "options.txt");
-		loadOptions();
-		saveOptions();
 
 		debugsKeys.add(keyShowShortcuts);
 		debugsKeys.add(keyReload);
@@ -292,6 +290,11 @@ public class GameSettings {
 		debugsKeys.add(keyReloadChunks);
 		debugsKeys.add(keySmoothLighting);
 	}
+
+	public void init() {
+		loadOptions();
+		saveOptions();
+	}
 	
 	public String getDisplayString(Option<?> option) {
 		if (option == null) return "";
diff --git a/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
index e2298fdac..1b95542cc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
@@ -4,6 +4,7 @@ import java.util.HashMap;
 import java.util.Map;
 
 import net.minecraft.client.render.entity.*;
+import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.model.*;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.EntityLightning;
@@ -105,12 +106,12 @@ public class EntityRenderDispatcher
         return getRenderer(entity.getClass());
     }
 
-    public void cacheActiveRenderInfo(World world, TextureManager textureManager, Font font, ICamera camera, GameSettings gameSettings, float partialTick)
+    public void cacheActiveRenderInfo(World world, TextureManager textureManager, FontRenderer fontRenderer, ICamera camera, GameSettings gameSettings, float partialTick)
     {
         this.world = world;
         this.textureManager = textureManager;
         this.gameSettings = gameSettings;
-        this.font = font;
+        this.fontRenderer = fontRenderer;
         this.camera = camera;
         viewLerpYaw = (float) camera.getYRot(partialTick);
         viewLerpPitch = (float) camera.getXRot(partialTick);
@@ -184,14 +185,14 @@ public class EntityRenderDispatcher
         return dx * dx + dy * dy + dz * dz;
     }
 
-    public Font getFont()
+    public FontRenderer getFont()
     {
-        return font;
+        return this.fontRenderer;
     }
 
     private final Map<Class<?>, EntityRenderer<?>> renderers;
     public static EntityRenderDispatcher instance = new EntityRenderDispatcher();
-    private Font font;
+    private FontRenderer fontRenderer;
     public static double renderPosX;
     public static double renderPosY;
     public static double renderPosZ;
diff --git a/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java b/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
index f2b1a9ca6..8f70c5cb5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
@@ -5,6 +5,7 @@ import static org.lwjgl.opengl.GL11.*;
 import java.util.List;
 import java.util.Random;
 
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -207,14 +208,14 @@ public class LoadingScreenRenderer
         }
 
         // Draw title and stage
-        minecraft.font.drawStringWithShadow(title, (width - minecraft.font.getStringWidth(title)) / 2, height / 2 - 4 - 16, 0xffffff);
-        minecraft.font.drawStringWithShadow(stage, (width - minecraft.font.getStringWidth(stage)) / 2, (height / 2 - 4) + 8, 0xffffff);
+        FontHelper.renderCentered(t, this.title, width / 2, height / 2 - 4 - 16).setShadow().call(this.minecraft.font);
+        FontHelper.renderCentered(t, this.stage, width / 2, (height / 2 - 4) + 8).setShadow().call(this.minecraft.font);
 
         // Draw tip
-        minecraft.font.drawStringWithShadow(tip, (width - minecraft.font.getStringWidth(tip)) / 2, (height / 2 - 4) + 32, 0xffffff);
-        
-        minecraft.renderer.endRenderGame(1.0f);
-        
-        minecraft.gameWindow.update();
+        FontHelper.renderCentered(t, this.tip, width / 2, (height / 2 - 4) + 32).setShadow().call(this.minecraft.font);
+
+        this.minecraft.renderer.endRenderGame(1.0f);
+
+        this.minecraft.gameWindow.update();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 03915e02f..82b871a68 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -6,7 +6,6 @@ import net.minecraft.client.entity.particle.Particle;
 import net.minecraft.client.entity.particle.ParticleDispatcher;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.block.model.BlockModelLeaves;
 import net.minecraft.client.render.camera.EntityCamera;
diff --git a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
index 20ed62e9a..e0071feb7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -33,6 +33,8 @@ import net.minecraft.client.render.dynamictexture.DynamicTextureLavaStill;
 import net.minecraft.client.render.dynamictexture.DynamicTextureTrommel;
 import net.minecraft.client.render.dynamictexture.DynamicTextureWaterFlow;
 import net.minecraft.client.render.dynamictexture.DynamicTextureWaterStill;
+import net.minecraft.client.render.font.FontDefault;
+import net.minecraft.client.render.font.FontRendererDefault;
 import net.minecraft.client.render.texture.meta.AnimationProperties;
 import net.minecraft.client.render.texture.stitcher.AtlasStitcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
@@ -172,12 +174,17 @@ public class TextureManager {
 
 		Texture texture = textureMap.get(name);
 		if (texture != null) return texture;
+		if (!Minecraft.getMinecraft().texturePackList.anyHasFile(name)) return null;
 
 		try {
-			texture = new TextureFile(name);
-			textureMap.put(name, texture);
-			idToTextureMap.put(texture.id(), texture);
-			return texture;
+			TextureFile t = new TextureFile(name);
+			if (!t.initFileTex(false)) {
+				t.delete();
+				return null;
+			}
+			textureMap.put(name, t);
+			idToTextureMap.put(t.id(), t);
+			return t;
 		} catch (Exception e) {
             LOGGER.error("Failed to create texture for '{}'!", name, e);
 		}
@@ -402,9 +409,9 @@ public class TextureManager {
 		}
 
 		Colors.loadColors();
-		
-		mc.font = new Font(mc, gameSettings, this);
-		
+
+        this.mc.font.init(this.mc.texturePackList);
+
 		mc.skinVariantList.refresh(errors);
 		mc.mainMenuBackground.refresh(errors);
 		
diff --git a/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
index 06044da4e..2d3c03fed 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render;
 import java.util.*;
 
 import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.tileentity.*;
 import net.minecraft.core.Global;
@@ -62,7 +63,7 @@ public class TileEntityRenderDispatcher
         return getRenderer(tileEntity) != null;
     }
 
-    public void cacheActiveRenderInfo(World world, TextureManager textureManager, Font font, ICamera camera, float partialTick)
+    public void cacheActiveRenderInfo(World world, TextureManager textureManager, FontRenderer fontRenderer, ICamera camera, float partialTick)
     {
         if(worldObj != world)
         {
@@ -70,7 +71,7 @@ public class TileEntityRenderDispatcher
         }
         this.textureManager = textureManager;
         this.camera = camera;
-        this.font = font;
+        this.fontRenderer = fontRenderer;
         viewLerpYaw = (float) camera.getYRot(partialTick);
         viewLerpPitch = (float) camera.getXRot(partialTick);
         viewLerpPosX = (float) camera.getX(partialTick);
@@ -120,14 +121,14 @@ public class TileEntityRenderDispatcher
         }
     }
 
-    public Font getFont()
+    public FontRenderer getFont()
     {
-        return font;
+        return fontRenderer;
     }
 
     private final Map<Class<?>, TileEntityRenderer<?>> renderers;
     public static TileEntityRenderDispatcher instance = new TileEntityRenderDispatcher();
-    private Font font;
+    private FontRenderer fontRenderer;
     public static double renderPosX;
     public static double renderPosY;
     public static double renderPosZ;
